import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { Entity } from '@s-ui/domain';
export var WorkTaskEntity = /*#__PURE__*/function (_Entity) {
  _inheritsLoose(WorkTaskEntity, _Entity);
  function WorkTaskEntity(_ref) {
    var autoRetry = _ref.autoRetry,
      config = _ref.config,
      createdAt = _ref.createdAt,
      finishedAt = _ref.finishedAt,
      id = _ref.id,
      log = _ref.log,
      name = _ref.name,
      onComplete = _ref.onComplete,
      onError = _ref.onError,
      parentId = _ref.parentId,
      percentage = _ref.percentage,
      start = _ref.start,
      status = _ref.status,
      taskId = _ref.taskId,
      updatedAt = _ref.updatedAt;
    return _Entity.call(this, {
      autoRetry: autoRetry,
      config: config,
      createdAt: createdAt,
      finishedAt: finishedAt,
      id: id,
      log: log,
      name: name,
      onComplete: onComplete,
      onError: onError,
      parentId: parentId,
      percentage: percentage,
      start: start,
      status: status,
      taskId: taskId,
      updatedAt: updatedAt
    }) || this;
  }
  var _proto = WorkTaskEntity.prototype;
  _proto.isInProgress = function isInProgress() {
    if (this._status.getValue() === this._config.get('AVAILABLE_STATUS').IN_PROGRESS) return true;
    return false;
  };
  _proto.isCompleted = function isCompleted() {
    if (this._status.getValue() === this._config.get('AVAILABLE_STATUS').COMPLETED) return true;
    return false;
  };
  _proto.isQueued = function isQueued() {
    if (this._status.getValue() === this._config.get('AVAILABLE_STATUS').QUEUED) return true;
    return false;
  };
  _proto.areDependenciesMet = function areDependenciesMet(siblingWorkList) {
    if (this._parentId.get() === null) return true;
    var parent = siblingWorkList.getById(this._parentId);
    if (parent === undefined || parent.isCompleted()) return true;
    return false;
  };
  _proto.execute = function execute() {
    this._status.setValue(this._config.get('AVAILABLE_STATUS').IN_PROGRESS);
    var startCallback = this._start.get();
    startCallback(this.toJSON());
  };
  _proto.toJSON = function toJSON() {
    return {
      autoRetry: this._autoRetry.toJSON(),
      createdAt: this._createdAt.toJSON(),
      finishedAt: this._finishedAt.toJSON(),
      id: this._id.toJSON(),
      log: this._log.toJSON(),
      name: this._name.toJSON(),
      onComplete: this._onComplete.toJSON(),
      onError: this._onError.toJSON(),
      parentId: this._parentId.toJSON(),
      percentage: this._percentage.toJSON(),
      start: this._start.toJSON(),
      status: this._status.toJSON(),
      taskId: this._taskId.toJSON(),
      updatedAt: this._updatedAt.toJSON()
    };
  };
  return WorkTaskEntity;
}(Entity);