import useMount from '@s-ui/react-hooks/lib/useMount/index.js';
var useDomainEventSubscriptions = function useDomainEventSubscriptions(domain, executeUseCase) {
  useMount(function () {
    var subscriptions = [];
    subscriptions.push(domain.get('run_simple_task_use_case').subscribe(function (_ref) {
      var result = _ref.result;
      return executeUseCase('process_queued_task_use_case', {
        localState: result
      });
    }), domain.get('run_task_use_case').subscribe(function (_ref2) {
      var result = _ref2.result;
      return executeUseCase('process_queued_task_use_case', {
        localState: result
      });
    }), domain.get('finish_work_task_use_case').subscribe(function (_ref3) {
      var result = _ref3.result;
      return executeUseCase('process_in_progress_task_use_case', {
        localState: result
      });
    }),
    /* domain.get('cancel_work_task_use_case')
      .subscribe(({result}) => executeUseCase('process_task_use_case',{localState: result})), */
    domain.get('error_work_task_use_case').subscribe(function (_ref4) {
      var result = _ref4.result;
      return executeUseCase('mark_error_task_use_case', {
        localState: result
      });
    }));
    return function () {
      return subscriptions.forEach(function (subscription) {
        return subscription.unsubscribe();
      });
    };
  });
};
export default useDomainEventSubscriptions;